local deformat = AceLibrary("Deformat-2.0")
local BB = AceLibrary("Babble-Boss-2.2")

MementoMori = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0", "AceConsole-2.0")
local mod = MementoMori

local WatchList = {}
local MemberLimit = 20
local Delay = 0
local TakeScreenshot = false

function mod:OnEnable()
	self:RegisterEvent("PLAYER_TARGET_CHANGED")
	self:RegisterEvent("UPDATE_MOUSEOVER_UNIT")
	
	self:RegisterEvent("CHAT_MSG_COMBAT_HOSTILE_DEATH")
	self:RegisterEvent("PLAYER_REGEN_ENABLED")
end

function mod:UPDATE_MOUSEOVER_UNIT()
	self:CheckTarget("mouseover")
end

function mod:PLAYER_TARGET_CHANGED()
	self:CheckTarget("target")
end

function mod:PLAYER_REGEN_ENABLED()
	if TakeScreenshot then
		self:TakeScreenShot()
	end
end

function mod:CHAT_MSG_COMBAT_HOSTILE_DEATH(msg)
	local mob = deformat(msg, UNITDIESOTHER)
	if mob and WatchList[mob] then
		TakeScreenshot = true
		WatchList[mob] = nil
	end
end

function mod:TakeScreenShot()
	if GetNumRaidMembers() >= MemberLimit then
		Screenshot()
		TakeScreenshot = false
	end
end

function mod:CheckTarget(unit)
	local type = UnitClassification(unit)
	if type ~= "worldboss" then return end
	
	local name = UnitName(unit)
	if WatchList[name] then return end
	if not BB:HasTranslation(name) then return end
	
	self:Print(("Boss found: %s"):format(name))
	WatchList[name] = true
end